;knight for michel 
;1999.6.7  I.N.
; 7.5 /7.7
;2021.3.10 PORTA->porta, PORTB->portb
;PIC16F84 CLK=RC

		INCLUDE 16F84.H

		.OSC	RC
		.PWRT	ON
		.WDT	OFF
		.PROTECT OFF

		;SRAM start address
		ORG	0CH

OUTH		DS 1
OUTL		DS 1

TM1		DS 1
TM2		DS 1

C01		DS 1
C02		DS 1
C03		DS 1
C04		DS 1
C05		DS 1
C06		DS 1
C07		DS 1
C08		DS 1
C09		DS 1
C10		DS 1
C11		DS 1
C12		DS 1
C13		DS 1

ZAN		EQU 3

D01		DS 1
D02		DS 1
D03		DS 1
D04		DS 1
D05		DS 1
D06		DS 1
D07		DS 1
D08		DS 1
D09		DS 1
D10		DS 1
D11		DS 1
D12		DS 1
D13		DS 1

POS		DS 1
DIR 		DS 1
WW		DS 1

		;EEPROM start address
		ORG	0
		GOTO START

START
		;PORT IN-OUT SETTING
		MOV	!porta,#0
		MOV	!portb,#0

		MOV POS,#1
		MOV C01,#64
		MOV C02,#0
		MOV C03,#0
		MOV C04,#0
		MOV C05,#0
		MOV C06,#0
		MOV C07,#0
		MOV C08,#0
		MOV C09,#0
		MOV C10,#0
		MOV C11,#0
		MOV C12,#0
		MOV C13,#0
		MOV D01,#0
		MOV D02,#0
		MOV D03,#0
		MOV D04,#0
		MOV D05,#0
		MOV D06,#0
		MOV D07,#0
		MOV D08,#0
		MOV D09,#0
		MOV D10,#0
		MOV D11,#0
		MOV D12,#0
		MOV D13,#0
		MOV OUTL,#0
		MOV OUTH,#0
		MOV DIR,#0

CONT

P01		AND OUTL,#0FEH
		MOV WW,#01H
		CJNE POS,#1,P01B
		MOV DIR,#0
		DJNZ C01,P01D
		CJE DIR,#0,P01A
		MOV C02,#32
		INC POS
		JMP P01E
P01A		MOV C02,#32
		INC POS
P01E		MOV D01,ZAN
P01B		CJE D01,#0,P01C
		DEC D01
		JMP P01D
P01C		MOV WW,#0
P01D		OR OUTL,WW

P02		AND OUTL,#0FDH
		MOV WW,#02H
		CJNE POS,#2,P02B
		DJNZ C02,P02D
		CJE DIR,#0,P02A
		MOV C01,#64
		DEC POS
		JMP P02E
P02A		MOV C03,#16
		INC POS
P02E		MOV D02,ZAN
P02B		CJE D02,#0,P02C
		DEC D02
		JMP P02D
P02C		MOV WW,#0
P02D		OR OUTL,WW

P03		AND OUTL,#0FBH
		MOV WW,#04H
		CJNE POS,#3,P03B
		DJNZ C03,P03D
		CJE DIR,#0,P03A
		MOV C02,#64
		DEC POS
		JMP P03E
P03A		MOV C04,#8
		INC POS
P03E		MOV D03,ZAN
P03B		CJE D03,#0,P03C
		DEC D03
		JMP P03D
P03C		MOV WW,#0
P03D		OR OUTL,WW

P04		AND OUTL,#0F7H
		MOV WW,#08H
		CJNE POS,#4,P04B
		DJNZ C04,P04D
		CJE DIR,#0,P04A
		MOV C03,#32
		DEC POS
		JMP P04E
P04A		MOV C05,#4
		INC POS
P04E		MOV D04,ZAN
P04B		CJE D04,#0,P04C
		DEC D04
		JMP P04D
P04C		MOV WW,#0
P04D		OR OUTL,WW

P05		AND OUTL,#0EFH
		MOV WW,#10H
		CJNE POS,#5,P05B
		DJNZ C05,P05D
		CJE DIR,#0,P05A
		MOV C04,#16
		DEC POS
		JMP P05E
P05A		MOV C06,#2
		INC POS
P05E		MOV D05,ZAN
P05B		CJE D05,#0,P05C
		DEC D05
		JMP P05D
P05C		MOV WW,#0
P05D		OR OUTL,WW

P06		AND OUTL,#0DFH
		MOV WW,#20H
		CJNE POS,#6,P06B
		DJNZ C06,P06D
		CJE DIR,#0,P06A
		MOV C05,#8
		DEC POS
		JMP P06E
P06A		MOV C07,#2
		INC POS
P06E		MOV D06,ZAN
P06B		CJE D06,#0,P06C
		DEC D06
		JMP P06D
P06C		MOV WW,#0
P06D		OR OUTL,WW

P07		AND OUTL,#0BFH
		MOV WW,#40H
		CJNE POS,#7,P07B
		DJNZ C07,P07D
		CJE DIR,#0,P07A
		MOV C06,#4
		DEC POS
		JMP P07E
P07A		MOV C08,#4
		INC POS
P07E		MOV D07,ZAN
P07B		CJE D07,#0,P07C
		DEC D07
		JMP P07D
P07C		MOV WW,#0
P07D		OR OUTL,WW

P08		AND OUTL,#07FH
		MOV WW,#80H
		CJNE POS,#8,P08B
		DJNZ C08,P08D
		CJE DIR,#0,P08A
		MOV C07,#2
		DEC POS
		JMP P08E
P08A		MOV C09,#8
		INC POS
P08E		MOV D08,ZAN
P08B		CJE D08,#0,P08C
		DEC D08
		JMP P08D
P08C		MOV WW,#0
P08D		OR OUTL,WW

P09		AND OUTH,#0FEH
		MOV WW,#01H
		CJNE POS,#9,P09B
		DJNZ C09,P09D
		CJE DIR,#0,P09A
		MOV C08,#2
		DEC POS
		JMP P09E
P09A		MOV C10,#16
		INC POS
P09E		MOV D09,ZAN
P09B		CJE D09,#0,P09C
		DEC D09
		JMP P09D
P09C		MOV WW,#0
P09D		OR OUTH,WW

P10		AND OUTH,#0FDH
		MOV WW,#02H
		CJNE POS,#10,P10B
		DJNZ C10,P10D
		CJE DIR,#0,P10A
		MOV C09,#4
		DEC POS
		JMP P10E
P10A		MOV C11,#32
		INC POS
P10E		MOV D10,ZAN
P10B		CJE D10,#0,P10C
		DEC D10
		JMP P10D
P10C		MOV WW,#0
P10D		OR OUTH,WW

P11		AND OUTH,#0FBH
		MOV WW,#04H
		CJNE POS,#11,P11B
		DJNZ C11,P11D
		CJE DIR,#0,P11A
		MOV C10,#8
		DEC POS
		JMP P11E
P11A		MOV C12,#64
		INC POS
P11E		MOV D11,ZAN
P11B		CJE D11,#0,P11C
		DEC D11
		JMP P11D
P11C		MOV WW,#0
P11D		OR OUTH,WW

P12		AND OUTH,#0F7H
		MOV WW,#08H
		CJNE POS,#12,P12B
		DJNZ C12,P12D
		CJE DIR,#0,P12A
		MOV C11,#16
		DEC POS
		JMP P12E
P12A		MOV C13,#64
		INC POS
P12E		MOV D12,ZAN
P12B		CJE D12,#0,P12C
		DEC D12
		JMP P12D
P12C		MOV WW,#0
P12D		OR OUTH,WW

P13		AND OUTH,#0EFH
		MOV WW,#10H
		CJNE POS,#13,P13B
		MOV DIR,#1
		DJNZ C13,P13D
		CJE DIR,#0,P13A
		MOV C12,#32
		DEC POS
		JMP P13E
P13A		MOV C12,#32
		DEC POS
P13E		MOV D13,ZAN
P13B		CJE D13,#0,P13C
		DEC D13
		JMP P13D
P13C		MOV WW,#0
P13D		OR OUTH,WW

		MOV portb,OUTL
		MOV porta,OUTH

		CALL WAIT
		JMP CONT

WAIT
		MOV	TM1,#150
LBL1		DJNZ	TM1,LBL1
		RET

